#!/usr/local/bin/perl -wT
# Copyright Andru Luvisi, 1999
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program (see the file COPYING); if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA


use CGI;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;

use strict;

use vars qw($query $num_answers @counts @guys $max @maxguys $maxguy);
use vars qw($template $subtemplate);

@guys = (
[ [ 4,4,2,1,4,4,4,3,4,1,1,4,3,1,3,4,4,4,1,4,], "kts/wickedwitch.tmpl", "The Wicked Witch" ], 
[ [ 1,1,4,1,1,2,2,1,1,1,3,2,1,1,1,2,1,1,2,1,], "kts/dorothy.tmpl", "Dorothy" ],
[ [ 1,3,2,4,2,3,2,2,1,3,1,1,1,4,4,1,2,2,3,2,], "kts/scarecrow.tmpl", "The Scarecrow" ],
[ [ 1,3,1,3,3,1,1,1,3,3,4,1,2,1,1,3,3,1,4,2,], "kts/cowardlylion.tmpl", "The Cowardly Lion" ],
[ [ 3,1,4,2,1,2,2,2,1,2,3,1,1,1,1,1,3,3,2,1,], "kts/tinman.tmpl", "The Tin Man" ],
[ [ 4,1,4,1,2,3,3,4,2,3,3,1,2,1,2,2,2,2,1,2,], "kts/auntieem.tmpl", "Auntie Em" ],
[ [ 1,1,4,4,1,1,1,1,1,4,4,2,5,1,4,3,1,1,4,1,], "kts/toto.tmpl", "Toto" ],
[ [ 4,3,2,2,2,2,3,4,2,2,2,1,2,1,3,2,3,1,1,2,], "kts/unclehenry.tmpl", "Uncle Henry" ], 
[ [ 3,4,1,3,4,4,1,3,4,1,1,3,4,3,1,1,4,3,2,3,], "kts/wizard.tmpl", "The Wizard" ], 
[ [ 2,2,4,2,4,4,4,3,3,3,4,4,5,2,4,3,3,4,3,4,], "kts/flyingmonkey.tmpl", "A Flying Monkey" ],
[ [ 1,2,3,4,1,1,1,3,1,4,4,2,4,1,1,2,1,1,4,3,], "kts/horseofmanycolors.tmpl", "The Horse of Many Colors" ],
[ [ 4,1,4,2,3,3,1,1,1,3,3,2,4,1,1,2,1,1,2,3,], "kts/lollypopguild.tmpl", "A Member of The Lollypop Guild" ], 
#[ [ 4,2,3,1,2,3,3,4,1,2,1,1,1,4,1,2,1,1,1,2,], "kts/glenda.tmpl", "Glenda" ],
[ [ 4,2,2,1,2,3,3,4,1,2,1,1,1,4,1,2,2,2,1,2,], "kts/glenda.tmpl", "Glinda" ], 
);

$query = CGI->new();
$num_answers = $query->param("num_answers");
@counts = (0) x $num_answers;

for(my $i = 0; $i < $num_answers; $i++) {
 my $answer = $query->param("answer_" . ($i + 1));
 for(my $j = 0; $j < @guys; $j++) {
  if($answer == $guys[$j][0][$i]) {
   $counts[$j]++;
  }
 }
}

$max = 0;
for(my $i = 0; $i < @counts; $i++) {
 if($counts[$i] > $max) {
  $max = $counts[$i];
 }
}

@maxguys = ();
for(my $i = 0; $i < @guys; $i++) {
 if($counts[$i] == $max) {
  push(@maxguys, $i);
 }
}

$maxguy = $maxguys[int(rand(@maxguys))];

$subtemplate = HTML::Template->new(filename => $guys[$maxguy][1],
				die_on_bad_params => 0);

$template = HTML::Template->new(filename => "kts.tmpl",
				die_on_bad_params => 0);
$template->param("message", $subtemplate->output());
$template->param("name", $guys[$maxguy][2]);
print $query->header(), $template->output(), "\n";
exit(0);

